%{

/* special registers
   $249-$251 Helpers for block copies
   $252 Base address for data segment
   $253 Frame pointer
   $254 Stack Pointer
*/

// the 00s are the outgoing parameters, plus the one for the pushj $23,
// $23 is going to hold the return value as well ... makes sense??!?
#define INTTMP 0x007f0ffe
#define INTVAR 0x007ff0fe
#define INTRET 0x00000001

#include "c.h"
#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
static void address(Symbol, Symbol, long);
static void blkfetch(int, int, int, int);
static void blkloop(int, int, int, int, int, int[]);
static void blkstore(int, int, int, int);
static void defaddress(Symbol);
static void defconst(int, int, Value);
static void defstring(int, char *);
static void defsymbol(Symbol);
static void doarg(Node);
static void emit2(Node);
static void export(Symbol);
static void clobber(Node);
static void function(Symbol, Symbol [], Symbol [], int);
static void global(Symbol);
static void import(Symbol);
static void local(Symbol);
static void progbeg(int, char **);
static void progend(void);
static void segment(int);
static void space(int);
static void target(Node);
static Symbol reg[32];
static Symbol regw;

static int cseg;
static int parameters = 0;
static int gotlabel = 0;
static int tmpregs[] = { 249, 250, 251 };

static void dumpnode(Node);

%}
%start stmt

%term CNSTF4=4113 CNSTF8=8209
%term CNSTI1=1045 CNSTI2=2069 CNSTI4=4117 CNSTI8=8213
%term CNSTP8=8215
%term CNSTU1=1046 CNSTU2=2070 CNSTU4=4118 CNSTU8=8214

%term ARGB=41
%term ARGF4=4129 ARGF8=8225
%term ARGI4=4133 ARGI8=8229
%term ARGP8=8231
%term ARGU4=4134 ARGU8=8230

%term ASGNB=57
%term ASGNF4=4145 ASGNF8=8241
%term ASGNI1=1077 ASGNI2=2101 ASGNI4=4149 ASGNI8=8245
%term ASGNP8=8247
%term ASGNU1=1078 ASGNU2=2102 ASGNU4=4150 ASGNU8=8246

%term INDIRB=73
%term INDIRF4=4161 INDIRF8=8257
%term INDIRI1=1093 INDIRI2=2117 INDIRI4=4165 INDIRI8=8261
%term INDIRP8=8263
%term INDIRU1=1094 INDIRU2=2118 INDIRU4=4166 INDIRU8=8262

%term CVFF4=4209 CVFF8=8305
%term CVFI4=4213 CVFI8=8309

%term CVIF4=4225 CVIF8=8321
%term CVII1=1157 CVII2=2181 CVII4=4229 CVII8=8325
%term CVIU1=1158 CVIU2=2182 CVIU4=4230 CVIU8=8326

%term CVPU8=8342

%term CVUI1=1205 CVUI2=2229 CVUI4=4277 CVUI8=8373
%term CVUP8=8375
%term CVUU1=1206 CVUU2=2230 CVUU4=4278 CVUU8=8374

%term NEGF4=4289 NEGF8=8385
%term NEGI4=4293 NEGI8=8389

%term CALLB=217
%term CALLF4=4305 CALLF8=8401
%term CALLI4=4309 CALLI8=8405
%term CALLP8=8407
%term CALLU4=4310 CALLU8=8406
%term CALLV=216

%term RETF4=4337 RETF8=8433
%term RETI4=4341 RETI8=8437
%term RETP8=8439
%term RETU4=4342 RETU8=8438
%term RETV=248

%term ADDRGP8=8455

%term ADDRFP8=8471

%term ADDRLP8=8487

%term ADDF4=4401 ADDF8=8497
%term ADDI4=4405 ADDI8=8501
%term ADDP8=8503
%term ADDU4=4406 ADDU8=8502

%term SUBF4=4417 SUBF8=8513
%term SUBI4=4421 SUBI8=8517
%term SUBP8=8519
%term SUBU4=4422 SUBU8=8518

%term LSHI4=4437 LSHI8=8533
%term LSHU4=4438 LSHU8=8534

%term MODI4=4453 MODI8=8549
%term MODU4=4454 MODU8=8550

%term RSHI4=4469 RSHI8=8565
%term RSHU4=4470 RSHU8=8566

%term BANDI4=4485 BANDI8=8581
%term BANDU4=4486 BANDU8=8582

%term BCOMI4=4501 BCOMI8=8597
%term BCOMU4=4502 BCOMU8=8598

%term BORI4=4517 BORI8=8613
%term BORU4=4518 BORU8=8614

%term BXORI4=4533 BXORI8=8629
%term BXORU4=4534 BXORU8=8630

%term DIVF4=4545 DIVF8=8641
%term DIVI4=4549 DIVI8=8645
%term DIVU4=4550 DIVU8=8646

%term MULF4=4561 MULF8=8657
%term MULI4=4565 MULI8=8661
%term MULU4=4566 MULU8=8662

%term EQF4=4577 EQF8=8673
%term EQI4=4581 EQI8=8677
%term EQU4=4582 EQU8=8678

%term GEF4=4593 GEF8=8689
%term GEI4=4597 GEI8=8693
%term GEU4=4598 GEU8=8694

%term GTF4=4609 GTF8=8705
%term GTI4=4613 GTI8=8709
%term GTU4=4614 GTU8=8710

%term LEF4=4625 LEF8=8721
%term LEI4=4629 LEI8=8725
%term LEU4=4630 LEU8=8726

%term LTF4=4641 LTF8=8737
%term LTI4=4645 LTI8=8741
%term LTU4=4646 LTU8=8742

%term NEF4=4657 NEF8=8753
%term NEI4=4661 NEI8=8757
%term NEU4=4662 NEU8=8758

%term JUMPV=584

%term LABELV=600

%term LOADB=233
%term LOADF4=4321 LOADF8=8417 LOADF16=16609
%term LOADI1=1253 LOADI2=2277 LOADI4=4325 LOADI8=8421
%term LOADP4=4327 LOADP8=8423 
%term LOADU1=1254 LOADU2=2278 LOADU4=4326 LOADU8=8422

%term VREGP=711
%%
reg:  INDIRI1(VREGP)     "# read register\n"
reg:  INDIRU1(VREGP)     "# read register\n"

reg:  INDIRI2(VREGP)     "# read register\n"
reg:  INDIRU2(VREGP)     "# read register\n"

reg:  INDIRF4(VREGP)     "# read register\n"
reg:  INDIRI4(VREGP)     "# read register\n"
reg:  INDIRU4(VREGP)     "# read register\n"

reg:  INDIRF8(VREGP)     "# read register\n"
reg:  INDIRI8(VREGP)     "# read register\n"
reg:  INDIRP8(VREGP)     "# read register\n"
reg:  INDIRU8(VREGP)     "# read register\n"

stmt: ASGNI1(VREGP,reg)  "# write register\n"
stmt: ASGNU1(VREGP,reg)  "# write register\n"

stmt: ASGNI2(VREGP,reg)  "# write register\n"
stmt: ASGNU2(VREGP,reg)  "# write register\n"

stmt: ASGNF4(VREGP,reg)  "# write register\n"
stmt: ASGNI4(VREGP,reg)  "# write register\n"
stmt: ASGNU4(VREGP,reg)  "# write register\n"

stmt: ASGNF8(VREGP,reg)  "# write register\n"
stmt: ASGNI8(VREGP,reg)  "# write register\n"
stmt: ASGNP8(VREGP,reg)  "# write register\n"
stmt: ASGNU8(VREGP,reg)  "# write register\n"
con: CNSTI1  "%a"
con: CNSTU1  "%a"

con: CNSTI2  "%a"
con: CNSTU2  "%a"

con: CNSTI4  "%a"
con: CNSTU4  "%a"

con: CNSTI8  "%a"
con: CNSTU8  "%a"
con: CNSTP8  "%a"
stmt: reg  ""	

reg:  ADDRGP8  "\tLDA\t$%c,%a\n"  !a->syms[0]->type || !isfunc(a->syms[0]->type) ? 1 : LBURG_MAX
reg:  ADDRGP8  "\tGETA\t$%c,%a\n"  a->syms[0]->type && isfunc(a->syms[0]->type) ? 1 : LBURG_MAX
reg:   ADDRFP8  "# ADDRFP\n"  2
reg:   ADDRLP8  "# ADDRLP\n"  2
addr:  ADDRFP8  ":__fp,%a"  range(a,0,255)
addr:  ADDRLP8  ":__fp,%a"  range(a,0,255)
addr:  ADDRGP8  "%a"  a->syms[0]->x.offset != 0 ? 1 : LBURG_MAX
addr:  reg  "$%0"  1
reg:   addr  "\tLDA\t$%c,%0\n"  1

stmt:  JUMPV(addr)  "\tGO\t$255,%0\n"  1
reg:  CALLF4(addr)  "\tPUSHGO\t$23,%0\n"  1
reg:  CALLF8(addr)  "\tPUSHGO\t$23,%0\n"  1
reg:  CALLI4(addr)  "\tPUSHGO\t$23,%0\n"  1
reg:  CALLI8(addr)  "\tPUSHGO\t$23,%0\n"  1
reg:  CALLU4(addr)  "\tPUSHGO\t$23,%0\n"  1
reg:  CALLU8(addr)  "\tPUSHGO\t$23,%0\n"  1
reg:  CALLP8(addr)  "\tPUSHGO\t$23,%0\n"  1
stmt:  CALLV(addr)  "\tPUSHGO\t$23,%0\n"  1

addrj:  ADDRGP8  "%a"  1
stmt:  JUMPV(addrj)  "\tJMP\t%0\n"  1
reg:  CALLF4(addrj)  "\tPUSHJ\t$23,%0\n"  1
reg:  CALLF8(addrj)  "\tPUSHJ\t$23,%0\n"  1
reg:  CALLI4(addrj)  "\tPUSHJ\t$23,%0\n"  1
reg:  CALLI8(addrj)  "\tPUSHJ\t$23,%0\n"  1
reg:  CALLU4(addrj)  "\tPUSHJ\t$23,%0\n"  1
reg:  CALLU8(addrj)  "\tPUSHJ\t$23,%0\n"  1
reg:  CALLP8(addrj)  "\tPUSHJ\t$23,%0\n"  1
stmt:  CALLV(addrj)  "\tPUSHJ\t$23,%0\n"  1

stmt: ASGNU8(addr,con8p)  "\tSTCO\t%1,%0\n"  1
stmt: ASGNI8(addr,con8p)  "\tSTCO\t%1,%0\n"  1

stmt: ASGNI1(addr,reg)  "\tSTB\t$%1,%0\n"  1 
stmt: ASGNI2(addr,reg)  "\tSTW\t$%1,%0\n"  1 
stmt: ASGNI4(addr,reg)  "\tSTT\t$%1,%0\n"  1 
stmt: ASGNI8(addr,reg)  "\tSTO\t$%1,%0\n"  1 
stmt: ASGNU1(addr,reg)  "\tSTBU\t$%1,%0\n"  1 
stmt: ASGNU2(addr,reg)  "\tSTWU\t$%1,%0\n"  1 
stmt: ASGNU4(addr,reg)  "\tSTTU\t$%1,%0\n"  1 
stmt: ASGNU8(addr,reg)  "\tSTOU\t$%1,%0\n"  1 
stmt: ASGNP8(addr,reg)  "\tSTOU\t$%1,%0\n"  1 

stmt: ASGNP8(VREGP,addr)  "\tLDA\t$%0,%1\n"  1

reg:  INDIRI1(addr)  "\tLDB\t$%c,%0\n"  1
reg:  INDIRI2(addr)  "\tLDW\t$%c,%0\n"  1
reg:  INDIRI4(addr)  "\tLDT\t$%c,%0\n"  1
reg:  INDIRI8(addr)  "\tLDO\t$%c,%0\n"  1
reg:  INDIRU1(addr)  "\tLDBU\t$%c,%0\n"  1
reg:  INDIRU2(addr)  "\tLDWU\t$%c,%0\n"  1
reg:  INDIRU4(addr)  "\tLDTU\t$%c,%0\n"  1
reg:  INDIRU8(addr)  "\tLDOU\t$%c,%0\n"  1
reg:  INDIRP8(addr)  "\tLDOU\t$%c,%0\n"  1

reg:  CVII4(INDIRI1(addr))  "\tLDB\t$%c,%0\n"  1
reg:  CVII8(INDIRI1(addr))  "\tLDB\t$%c,%0\n"  1
reg:  CVII4(INDIRI2(addr))  "\tLDW\t$%c,%0\n"  1
reg:  CVII8(INDIRI2(addr))  "\tLDW\t$%c,%0\n"  1
reg:  CVII8(INDIRI4(addr))  "\tLDT\t$%c,%0\n"  1

reg:  CVUU4(INDIRU1(addr))  "\tLDBU\t$%c,%0\n"  1
reg:  CVUU8(INDIRU1(addr))  "\tLDBU\t$%c,%0\n"  1
reg:  CVUU4(INDIRU2(addr))  "\tLDWU\t$%c,%0\n"  1
reg:  CVUU8(INDIRU2(addr))  "\tLDWU\t$%c,%0\n"  1
reg:  CVUU8(INDIRU4(addr))  "\tLDTU\t$%c,%0\n"  1

reg:  CVUI4(INDIRU1(addr))  "\tLDBU\t$%c,%0\n"  1
reg:  CVUI8(INDIRU1(addr))  "\tLDBU\t$%c,%0\n"  1
reg:  CVUI4(INDIRU2(addr))  "\tLDWU\t$%c,%0\n"  1
reg:  CVUI8(INDIRU2(addr))  "\tLDWU\t$%c,%0\n"  1
reg:  CVUI8(INDIRU4(addr))  "\tLDTU\t$%c,%0\n"  1

reg:  INDIRF4(addr)  "\tLDSF\t$%c,%0\n"  1
reg:  INDIRF8(addr)  "\tLDOU\t$%c,%0\n"  1

stmt: ASGNF4(addr,reg)  "\tSTSF\t$%1,%0\n"  1
stmt: ASGNF8(addr,reg)  "\tSTOU\t$%1,%0\n"  1

con8p:  CNSTI1  "%a"  range(a,0,255)  
con8p:  CNSTI2  "%a"  range(a,0,255)
con8p:  CNSTI4  "%a"  range(a,0,255)
con8p:  CNSTI8  "%a"  range(a,0,255)
con8p:  CNSTU1  "%a"  range(a,0,255)
con8p:  CNSTU2  "%a"  range(a,0,255)
con8p:  CNSTU4  "%a"  range(a,0,255)
con8p:  CNSTU8  "%a"  range(a,0,255)
con8p:  CNSTP8  "%a"  range(a,0,255)
rc:  con8p  "%0"
rc:  reg    "$%0"

con1:  CNSTI1  "%a"  range(a,1,1)  
con1:  CNSTI2  "%a"  range(a,1,1)
con1:  CNSTI4  "%a"  range(a,1,1)
con1:  CNSTI8  "%a"  range(a,1,1)
con1:  CNSTU1  "%a"  range(a,1,1)
con1:  CNSTU2  "%a"  range(a,1,1)
con1:  CNSTU4  "%a"  range(a,1,1)
con1:  CNSTU8  "%a"  range(a,1,1)
con1:  CNSTP8  "%a"  range(a,1,1)
con2:  CNSTI1  "%a"  range(a,2,2)  
con2:  CNSTI2  "%a"  range(a,2,2)
con2:  CNSTI4  "%a"  range(a,2,2)
con2:  CNSTI8  "%a"  range(a,2,2)
con2:  CNSTU1  "%a"  range(a,2,2)
con2:  CNSTU2  "%a"  range(a,2,2)
con2:  CNSTU4  "%a"  range(a,2,2)
con2:  CNSTU8  "%a"  range(a,2,2)
con2:  CNSTP8  "%a"  range(a,2,2)
con3:  CNSTI1  "%a"  range(a,3,3)  
con3:  CNSTI2  "%a"  range(a,3,3)
con3:  CNSTI4  "%a"  range(a,3,3)
con3:  CNSTI8  "%a"  range(a,3,3)
con3:  CNSTU1  "%a"  range(a,3,3)
con3:  CNSTU2  "%a"  range(a,3,3)
con3:  CNSTU4  "%a"  range(a,3,3)
con3:  CNSTU8  "%a"  range(a,3,3)
con3:  CNSTP8  "%a"  range(a,3,3)
con4:  CNSTI1  "%a"  range(a,4,4)  
con4:  CNSTI2  "%a"  range(a,4,4)
con4:  CNSTI4  "%a"  range(a,4,4)
con4:  CNSTI8  "%a"  range(a,4,4)
con4:  CNSTU1  "%a"  range(a,4,4)
con4:  CNSTU2  "%a"  range(a,4,4)
con4:  CNSTU4  "%a"  range(a,4,4)
con4:  CNSTU8  "%a"  range(a,4,4)
con4:  CNSTP8  "%a"  range(a,4,4)

reg:  ADDU4(LSHU4(reg,con1),rc)  "\t2ADDU\t$%c,$%0,%1\n"  1
reg:  ADDU8(LSHU8(reg,con1),rc)  "\t2ADDU\t$%c,$%0,%1\n"  1
reg:  ADDU4(LSHU4(reg,con2),rc)  "\t4ADDU\t$%c,$%0,%1\n"  1
reg:  ADDU8(LSHU8(reg,con2),rc)  "\t4ADDU\t$%c,$%0,%1\n"  1
reg:  ADDU4(LSHU4(reg,con3),rc)  "\t8ADDU\t$%c,$%0,%1\n"  1
reg:  ADDU8(LSHU8(reg,con3),rc)  "\t8ADDU\t$%c,$%0,%1\n"  1
reg:  ADDU4(LSHU4(reg,con4),rc)  "\t16ADDU\t$%c,$%0,%1\n"  1
reg:  ADDU8(LSHU8(reg,con4),rc)  "\t16ADDU\t$%c,$%0,%1\n"  1

reg:  MULI4(reg,rc)  "\tMUL\t$%c,$%0,%1\n"  1
reg:  MULI8(reg,rc)  "\tMUL\t$%c,$%0,%1\n"  1
reg:  MULU4(reg,rc)  "\tMULU\t$%c,$%0,%1\n"  1
reg:  MULU8(reg,rc)  "\tMULU\t$%c,$%0,%1\n"  1
reg:  MULI4(rc,reg)  "\tMUL\t$%c,$%1,%0\n"  1
reg:  MULI8(rc,reg)  "\tMUL\t$%c,$%1,%0\n"  1
reg:  MULU4(rc,reg)  "\tMULU\t$%c,$%1,%0\n"  1
reg:  MULU8(rc,reg)  "\tMULU\t$%c,$%1,%0\n"  1
reg:  DIVI4(reg,rc)  "\tDIV\t$%c,$%0,%1\n"  1
reg:  DIVI8(reg,rc)  "\tDIV\t$%c,$%0,%1\n"  1
reg:  DIVU4(reg,rc)  "\tDIVU\t$%c,$%0,%1\n"  1
reg:  DIVU8(reg,rc)  "\tDIVU\t$%c,$%0,%1\n"  1
reg:  MODI4(reg,rc)  "\tDIV\t$%c,$%0,%1\n\tGET\t$%c,:rR\n"  2
reg:  MODI8(reg,rc)  "\tDIV\t$%c,$%0,%1\n\tGET\t$%c,:rR\n"  2
reg:  MODU4(reg,rc)  "\tDIVU\t$%c,$%0,%1\n\tGET\t$%c,:rR\n"  2
reg:  MODU8(reg,rc)  "\tDIVU\t$%c,$%0,%1\n\tGET\t$%c,:rR\n"  2
reg:  ADDI4(reg,rc)  "\tADD\t$%c,$%0,%1\n"  1
reg:  ADDI8(reg,rc)  "\tADD\t$%c,$%0,%1\n"  1
reg:  ADDU4(reg,rc)  "\tADDU\t$%c,$%0,%1\n"  1
reg:  ADDU8(reg,rc)  "\tADDU\t$%c,$%0,%1\n"  1
reg:  ADDP8(reg,rc)  "\tADDU\t$%c,$%0,%1\n"  1
reg:  SUBI4(reg,rc)  "\tSUB\t$%c,$%0,%1\n"  1
reg:  SUBI8(reg,rc)  "\tSUB\t$%c,$%0,%1\n"  1
reg:  SUBU4(reg,rc)  "\tSUBU\t$%c,$%0,%1\n"  1
reg:  SUBU8(reg,rc)  "\tSUBU\t$%c,$%0,%1\n"  1
reg:  SUBP8(reg,rc)  "\tSUBU\t$%c,$%0,%1\n"  1
reg:  SUBI4(con8p,rc)  "\tNEG\t$%c,%0,%1\n"  1
reg:  SUBI8(con8p,rc)  "\tNEG\t$%c,%0,%1\n"  1
reg:  SUBU4(con8p,rc)  "\tNEGU\t$%c,%0,%1\n"  1
reg:  SUBU8(con8p,rc)  "\tNEGU\t$%c,%0,%1\n"  1
reg:  SUBP8(con8p,rc)  "\tNEGU\t$%c,%0,%1\n"  1
reg:  BANDI4(reg,rc)  "\tAND\t$%c,$%0,%1\n"  1
reg:  BANDI8(reg,rc)  "\tAND\t$%c,$%0,%1\n"  1
reg:  BANDU4(reg,rc)  "\tAND\t$%c,$%0,%1\n"  1
reg:  BANDU8(reg,rc)  "\tAND\t$%c,$%0,%1\n"  1
reg:  BORI4(reg,rc)   "\tOR\t$%c,$%0,%1\n"  1
reg:  BORI8(reg,rc)   "\tOR\t$%c,$%0,%1\n"  1
reg:  BORU4(reg,rc)   "\tOR\t$%c,$%0,%1\n"  1
reg:  BORU8(reg,rc)   "\tOR\t$%c,$%0,%1\n"  1
reg:  BXORI4(reg,rc)  "\tXOR\t$%c,$%0,%1\n"  1
reg:  BXORI8(reg,rc)  "\tXOR\t$%c,$%0,%1\n"  1
reg:  BXORU4(reg,rc)  "\tXOR\t$%c,$%0,%1\n"  1
reg:  BXORU8(reg,rc)  "\tXOR\t$%c,$%0,%1\n"  1
reg:  LSHI4(reg,rc)  "\tSL\t$%c,$%0,%1\n"  1
reg:  LSHI8(reg,rc)  "\tSL\t$%c,$%0,%1\n"  1
reg:  LSHU4(reg,rc)  "\tSLU\t$%c,$%0,%1\n"  1
reg:  LSHU8(reg,rc)  "\tSLU\t$%c,$%0,%1\n"  1
reg:  RSHI4(reg,rc)  "\tSR\t$%c,$%0,%1\n"  1
reg:  RSHI8(reg,rc)  "\tSR\t$%c,$%0,%1\n"  1
reg:  RSHU4(reg,rc)  "\tSRU\t$%c,$%0,%1\n"  1
reg:  RSHU8(reg,rc)  "\tSRU\t$%c,$%0,%1\n"  1

reg:  BCOMI4(reg)  "\tNOR\t$%c,$%0,0\n"  1
reg:  BCOMI8(reg)  "\tNOR\t$%c,$%0,0\n"  1
reg:  BCOMU4(reg)  "\tNOR\t$%c,$%0,0\n"  1
reg:  BCOMU8(reg)  "\tNOR\t$%c,$%0,0\n"  1
reg:  NEGI4(reg)  "\tNEG\t$%c,0,$%0\n"  1
reg:  NEGI8(reg)  "\tNEG\t$%c,0,$%0\n"  1

reg:  LOADI1(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADI2(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADI4(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADI8(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADU1(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADU2(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADU4(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADU8(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADP8(reg)  "\tSET\t$%c,$%0\n"  move(a)

reg:  ADDF4(reg,reg)  "\tFADD\t$%c,$%0,$%1\n"  1
reg:  ADDF8(reg,reg)  "\tFADD\t$%c,$%0,$%1\n"  1
reg:  DIVF4(reg,reg)  "\tFDIV\t$%c,$%0,$%1\n"  1
reg:  DIVF8(reg,reg)  "\tFDIV\t$%c,$%0,$%1\n"  1
reg:  MULF4(reg,reg)  "\tFMUL\t$%c,$%0,$%1\n"  1
reg:  MULF8(reg,reg)  "\tFMUL\t$%c,$%0,$%1\n"  1
reg:  SUBF4(reg,reg)  "\tFSUB\t$%c,$%0,$%1\n"  1
reg:  SUBF8(reg,reg)  "\tFSUB\t$%c,$%0,$%1\n"  1

reg:  LOADF4(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  LOADF8(reg)  "\tSET\t$%c,$%0\n"  move(a)

reg:  NEGF4(reg)  "\tXOR\t$255,$255,$255\n\tFSUB\t$%c,$255,$%0\n"  2
reg:  NEGF8(reg)  "\tXOR\t$255,$255,$255\n\tFSUB\t$%c,$255,$%0\n"  2

reg:  CVII4(reg)  "\tSL\t$%c,$%0,8*(8-%a)\n\tSR\t$%c,$%c,8*(8-%a)\n"  2
reg:  CVII8(reg)  "\tSL\t$%c,$%0,8*(8-%a)\n\tSR\t$%c,$%c,8*(8-%a)\n"  2
reg:  CVUU4(reg)  "\tSLU\t$%c,$%0,8*(8-%a)\n\tSRU\t$%c,$%c,8*(8-%a)\n"  2
reg:  CVUU8(reg)  "\tSLU\t$%c,$%0,8*(8-%a)\n\tSRU\t$%c,$%c,8*(8-%a)\n"  2
reg:  CVUI4(reg)  "\tSLU\t$%c,$%0,8*(8-%a)\n\tSRU\t$%c,$%c,8*(8-%a)\n"  2
reg:  CVUI8(reg)  "\tSLU\t$%c,$%0,8*(8-%a)\n\tSRU\t$%c,$%c,8*(8-%a)\n"  2
reg:  CVIU4(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  CVIU8(reg)  "\tSET\t$%c,$%0\n"  move(a)

reg:  CVFF4(reg)  "\tSTSF\t$%0,:__fconv\n\tLDSF\t$%c,:__fconv\n"  2
reg:  CVFF8(reg)  "\tSET\t$%c,$%0\n"  move(a)
reg:  CVFI4(reg)  "\tFIX\t$%c,$%0\n\tSL\t$%c,$%c,8*(8-%a)\n\tSR\t$%c,$%c,8*(8-%a)\n"  3
reg:  CVFI8(reg)  "\tFIX\t$%c,$%0\n"  1
reg:  CVIF4(reg)  "\tSFLOT\t$%c,$%0\n"  1
reg:  CVIF8(reg)  "\tFLOT\t$%c,$%0\n"  1

stmt:  LABELV  "%a\tIS\t@\n"  1

stmt:  EQI4(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBZ\t$255,%a\n"  2
stmt:  EQI8(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBZ\t$255,%a\n"  2
stmt:  EQU4(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBZ\t$255,%a\n"  2
stmt:  EQU8(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBZ\t$255,%a\n"  2
stmt:  GEI4(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBNN\t$255,%a\n"  2
stmt:  GEI8(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBNN\t$255,%a\n"  2
stmt:  GEU4(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBNN\t$255,%a\n"  2
stmt:  GEU8(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBNN\t$255,%a\n"  2
stmt:  GTI4(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBP\t$255,%a\n"  2
stmt:  GTI8(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBP\t$255,%a\n"  2
stmt:  GTU4(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBP\t$255,%a\n"  2
stmt:  GTU8(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBP\t$255,%a\n"  2
stmt:  LEI4(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBNP\t$255,%a\n"  2
stmt:  LEI8(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBNP\t$255,%a\n"  2
stmt:  LEU4(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBNP\t$255,%a\n"  2
stmt:  LEU8(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBNP\t$255,%a\n"  2
stmt:  LTI4(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBN\t$255,%a\n"  2
stmt:  LTI8(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBN\t$255,%a\n"  2
stmt:  LTU4(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBN\t$255,%a\n"  2
stmt:  LTU8(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBN\t$255,%a\n"  2
stmt:  NEI4(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBNZ\t$255,%a\n"  2
stmt:  NEI8(reg,rc)  "\tCMP\t$255,$%0,%1\n\tBNZ\t$255,%a\n"  2
stmt:  NEU4(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBNZ\t$255,%a\n"  2
stmt:  NEU8(reg,rc)  "\tCMPU\t$255,$%0,%1\n\tBNZ\t$255,%a\n"  2

stmt:  EQF4(reg,reg)  "\tFEQL\t$255,$%0,$%1\n\tBP\t$255,%a\n"  2
stmt:  EQF8(reg,reg)  "\tFEQL\t$255,$%0,$%1\n\tBP\t$255,%a\n"  2
stmt:  GEF4(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBNN\t$255,%a\n"  2
stmt:  GEF8(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBNN\t$255,%a\n"  2
stmt:  GTF4(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBP\t$255,%a\n"  2
stmt:  GTF8(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBP\t$255,%a\n"  2
stmt:  LEF4(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBNP\t$255,%a\n"  2
stmt:  LEF8(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBNP\t$255,%a\n"  2
stmt:  LTF4(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBN\t$255,%a\n"  2
stmt:  LTF8(reg,reg)  "\tFCMP\t$255,$%0,$%1\n\tBN\t$255,%a\n"  2
stmt:  NEF4(reg,reg)  "\tFEQL\t$255,$%0,$%1\n\tBNP\t$255,%a\n"  2
stmt:  NEF8(reg,reg)  "\tFEQL\t$255,$%0,$%1\n\tBNP\t$255,%a\n"  2

reg:  con  "# con // very important one !!!\n"  1 

stmt: RETF4(reg)  "# ret\n"  1
stmt: RETF8(reg)  "# ret\n"  1
stmt: RETI4(reg)  "# ret\n"  1
stmt: RETU4(reg)  "# ret\n"  1
stmt: RETI8(reg)  "# ret\n"  1
stmt: RETU8(reg)  "# ret\n"  1
stmt: RETP8(reg)  "# ret\n"  1
stmt: RETV(reg)   "# ret\n"  1

stmt: ARGF4(reg)  "# arg\n"  1
stmt: ARGF8(reg)  "# arg\n"  1
stmt: ARGI4(reg)  "# arg\n"  1
stmt: ARGI8(reg)  "# arg\n"  1
stmt: ARGP8(reg)  "# arg\n"  1
stmt: ARGU4(reg)  "# arg\n"  1
stmt: ARGU8(reg)  "# arg\n"  1

stmt: ASGNB(reg,INDIRB(reg))  "# ASGNB\n"  1

%%

static void dumpnode(Node p) {
	static int offset=0; 
	int i;
	for (i=0; i<offset; ++i) fprint(stderr, " ");
	fprint(stderr, "dumpnode: %s [%s(#%x),%s(#%x),%s(#%x)]\n", opname(p->op), 
		p->syms[0] ? p->syms[0]->name : "", p->syms[0] ? p->syms[0]->u.c.v.i : 0, 
		p->syms[1] ? p->syms[1]->name : "", p->syms[1] ? p->syms[1]->u.c.v.i : 0,
		p->syms[2] ? p->syms[2]->name : "", p->syms[2] ? p->syms[2]->u.c.v.i : 0
	);
	offset+=2;
	if (p->kids[0]) dumpnode(p->kids[0]);
	if (p->kids[1]) dumpnode(p->kids[1]);
	offset-=2;
}

static void progend() {
	print("\tPREFIX\t:\t\t%% -- PREFIX CHANGE --\n");
	// we always start out in data and end in it
	segment(DATA);
}

static void progbeg(int argc, char *argv[]) {
    int i;

    // shared progbeg, [2]p.371
    {
        union {
            char c;
            int i;
        } u;
        u.i = 0;
        u.c = 1;
        swap = (u.i == 1) != IR->little_endian;
    }

    fprint(stderr, "We are %s endian\n", swap ? "little" : "big");
    
    // let LCC parse flags
    parseflags(argc, argv);
    
    // parse our own flags
    for (i = 0; i < argc; i++) {
        if (strncmp(argv[i], "-b", 2) == 0)
            ; // bollocks = 1;
    }
    
    // emit prefix for this file
    char buffer[strlen(firstfile)];
    strcpy(buffer, firstfile);
    if (buffer[0] >= '0' && buffer[0] <= '9') buffer[0] = 'a' + buffer[0] - '0';
    for(i=0; buffer[i]; ++i) if (buffer[i] == '.' || buffer[i] == '/' || buffer[i] == '\\') buffer[i] = '_';
    time_t t;
    print("\tPREFIX\t%s_%d:\t%% -- PREFIX CHANGE --\n", buffer, time(&t));
        
    cseg = DATA;

    for (i = 0; i < 32; i++)
       reg[i]  = mkreg("%d", i, 1, IREG);
    regw = mkwildcard(reg);

    tmask[IREG] = INTTMP;
    vmask[IREG] = INTVAR;
}

static Symbol rmap(int opk) {
    return regw;
}

static void target(Node p) {
	Node q;

        assert(p);
        switch (specific(p->op)) {
	case CALL+F: case CALL+I: case CALL+U: case CALL+P:
		setreg(p, reg[23]); // $0 from the computing column, $23 after it returned
		break;
        case RET+F: case RET+I: case RET+U: case RET+P:
		if (parameters == 0)
			rtarget(p, 0, reg[0]);
		break;
        // Target registers starting from 24, eight of them
	case ARG+F: case ARG+I: case ARG+P: case ARG+U:
		if (p->syms[2]->u.c.v.i < 64)
			rtarget(p, 0, reg[p->syms[2]->u.c.v.i/8 + 24]);
		break;
        }
}

static void clobber(Node p) {}

static void emitintconst(int reg, int size, int issigned, unsigned long value) {
    fprint(stderr, "emitintconst(%d, %d, %d, 0x%x)\n", reg, size, issigned, value);	

    int negative = 0;

    // handle special case 0x0
    if (value == 0) {
	print("\tXOR\t$%d,$%d,$%d\n", reg, reg, reg);
	return;
    }

    // no point looking at anything above this as this machine can't and won't
    // store anything there
    if (size > sizeof(unsigned long)) size = sizeof(unsigned long);
   
    // if it's a negative number we reverse it and do a substract, in most
    // cases that's even faster than emitting ff x 64bit
    if (issigned && (long)value < 0) {
	fprint(stderr, "Number is negative\n");
	negative = 1;
	(long)value = -(long)value;
    }

    // find out what bit ranges we have to handle
    int i, printed = 0, parts[4] = {0,0,0,0};
    long temp = value;
    int bound = size == 1 ? 1 : size/2;
    for (i = 0; i < bound; ++i) {
        parts[3-i] = (temp & 0xffff);
        temp >>= 16;
    }

    fprint(stderr, "parts: %x,%x,%x,%x\n", parts[0], parts[1], parts[2], parts[3]);

    if (parts[0]) {
        // prevent warning
        temp = value;
        temp >>= 16;
        temp >>= 16;
        temp >>= 16;
	print("\tSETH\t$%d,#%x\n", reg, temp & 0xffff);
        printed = 1;
    }
    if (parts[1]) {
        temp = value;
        temp >>= 16;
        temp >>= 16;
        if (printed)
	    print("\tINCMH\t$%d,#%x\n", reg, temp & 0xffff);
	else
	    print("\tSETMH\t$%d,#%x\n", reg, temp & 0xffff);
        printed = 1;
    }
    if (parts[2]) {
        if (printed)
	    print("\tINCML\t$%d,#%x\n", reg, (value >> 16) & 0xffff);
	else
	    print("\tSETML\t$%d,#%x\n", reg, (value >>16) & 0xffff);
        printed = 1;
    }
    if (parts[3]) {
        if (printed)
	    print("\tINCL\t$%d,#%x\n", reg, value & 0xffff);
	else
	    print("\tSETL\t$%d,#%x\n", reg, value & 0xffff);
    }

    if (negative) {
	print("\tNEG\t$%d,0,$%d\n", reg, reg);
    }
}

static void emit2(Node p) {
        int dst, n, src, sz, ty;
        static int ty0;
        Symbol q;
	char *op,*target;

        switch (specific(p->op)) {
        case ARG+F: case ARG+I: case ARG+P: case ARG+U:
                if (p->syms[2]->u.c.v.i < 64) break;

		n = framesize - (p->syms[2]->u.c.v.i - 56);
                ty = optype(p->op);
                sz = opsize(p->op);
                src = getregnum(p->x.kids[0]);
		if (n >= 256) {
			emitintconst(255, 4, 0, n);		
			target = "$255";
		} else {
			target = stringd(n);
		}
		assert(sz >= 4); // LCC only generates trees with sz >= 4
/*
		if (ty == F && sz == 4) op = "STSF";
		else if (ty == F && sz == 8) op = "STOU";
		else if (specific(p->op) & U && sz == 4) op = "STTU";
		else if (specific(p->op) & U && sz == 8) op = "STOU";
		else if (sz == 4) op = "STT";
		else if (sz == 8) op = "STO";
		else assert(0);
*/
		// it the target is a variadic function, it expects everything as register dumps
		op = "STOU";
		print("\t%s\t$%d,:__fp,%s\n", op, src, target); 
                break;

        case ASGN+B:
                dalign = salign = p->syms[1]->u.c.v.i;
                blkcopy(getregnum(p->x.kids[0]), 0,
                        getregnum(p->x.kids[1]), 0,
                        p->syms[0]->u.c.v.i, tmpregs);
		break;

        case CNST+I: case CNST+U: case CNST+P:
	    fprint(stderr, "CNST in emit2\n");
            emitintconst(getregnum(p), opsize(p->op), specific(p->op) & U, p->syms[0]->u.c.v.i);
            break;

	case RET+I: case RET+U: case RET+P: case RET+F:
		// copy the return value manually because we get a register clash otherwise ...
		if (parameters != 0)
			print("\tSET\t$0,$%d\n", getregnum(p->x.kids[0]));
		break;
	case ADDRF+P: case ADDRL+P:
		fprint(stderr, "ADDR(FL)P, offset: %x\n", p->syms[0]->x.offset);
		assert(p->syms[0]->x.offset < 0 || p->syms[0]->x.offset > 255);
		// easy case, it's negative but between -1 and -255
		if (p->syms[0]->x.offset >= -255 && p->syms[0]->x.offset < 0) {
			print("\tSUBU\t$%d,:__fp,%d\n", getregnum(p), -p->syms[0]->x.offset);
		} else {
			emitintconst(getregnum(p), 8, 0, p->syms[0]->x.offset < 0 ? -p->syms[0]->x.offset : p->syms[0]->x.offset);
			if (p->syms[0]->x.offset > 0) {
				print("\tLDA\t$%d,:__fp,$%d\n",getregnum(p), getregnum(p));
			} else {
				print("\tSUBU\t$%d,:__fp,$%d\n", getregnum(p), getregnum(p));
			}
		}
		break;
        }
}

static void doarg(Node p) {
	fprint(stderr, "doarg(%s)\n", p->syms[0]->x.name);
        p->syms[RX] = intconst(mkactual(8, roundup(p->syms[0]->u.c.v.i, 8)));
}

static void local(Symbol p) {
    fprint(stderr, "local(%s)\n", p->name);

    // put even lightly used variables in registers (including floats)
    if (isscalar(p->type) && !p->addressed) {
        fprint(stderr, "Requesting register\n");
        p->sclass = REGISTER;
    }

    if (askregvar(p, rmap(ttob(p->type))) == 0) {
        fprint(stderr, "Got mkauto\n");
	// mkaotu is trying to be clever by assuming that the stack grows towards lower addresses, well
	// for MMIX,it doesn't
	offset -= p->type->size;
        mkauto(p);
	p->x.offset = -p->x.offset;
	p->x.name = stringd(p->x.offset);
	offset += p->type->size;
    }
    fprint(stderr, "end local()\n");
}

static void function(Symbol f, Symbol caller[], Symbol callee[], int ncalls) {
        int i, rJoffset, fpoffset;
	Symbol r;

	// reset everything for everyfunction, every backend does that
        usedmask[0] = 0;
        freemask[0] = ~(unsigned)0;

	// we assign registers to parameters, clear up possible junk from previous funcs
	for (i = 0; i < 32; ++i) {
            if (reg[i]->x.regnode->vbl != NULL) { fprint(stderr, "%d was full\n", i); reg[i]->x.regnode->vbl = NULL; }
	}

	// maxargoffset = the size of the stack block for outgoing arguments
	// offset = holds the frame offset for the next parameter (initially)
	// maxoffset = ?
        maxargoffset = offset = maxoffset = 0;

	// find number of args
	for (i = 0; callee[i]; ++i) ;
	// Used by target and emit2
	parameters = i;

	// if we are variadic we have to store every possible parameter on the stack
	if (variadic(f->type) && parameters < 8) offset += (8-parameters)*8;

	fprint(stderr, "Function: %s, going through callees, offset: %d\n", f->x.name, offset);
	// we are allocating the registers for incoming parameters here, straight forward
        for (--i; i >= 0; --i) {
                Symbol p = callee[i];
                Symbol q = caller[i];

		fprint(stderr, "i: %d, addressed: %d, variadic: %d\n", i, p->addressed, variadic(f->type));
		if (i < 8 && !p->addressed && !variadic(f->type)) {
			// assign a register
			p->sclass = q->sclass = REGISTER;
			askregvar(p, reg[i]);
			assert(p->x.regnode && p->x.regnode->vbl == p);
			q->x = p->x;
			q->type = p->type;
			fprint(stderr, "Assigning register %d to parameter %d\n", i, i);
		} else if (i < 8) {
			// get a memory location
			p->x.offset = offset;
			p->x.name = stringd(offset);
			p->sclass = AUTO;
			q->sclass = REGISTER;
			askregvar(q, reg[i]);
			assert(q->x.regnode);
			fprint(stderr, "Assigning offset %d to parameter %d\n", offset, i);
			offset += 8;
		} else {
			// it's in parents frame, do it like mkauto but with negative offset
			p->x.offset = q->x.offset = -( (i-7) * 8 - 8 + p->type->size);
			p->x.name = q->x.name = stringd(-( (i-7) * 8 - 8 + p->type->size));
			assert(q->sclass != REGISTER);
			fprint(stderr, "Assigning offset %d to parameter %d\n", p->x.offset, i);
		}
        }
	fprint(stderr, "Done. Next offset: %d\n", offset);

	// Give the old framepointer some space
	fpoffset = offset;
	offset += 8;

	// increase next offset if we need to save rJ to the frame
	if (ncalls != 0) {
		rJoffset = offset;
		offset += 8;
		fprint(stderr, "Increasing offset for rJ, now %d\n", offset);
	}

	fprint(stderr, "Calling gencode(), next offset: %d, maxoffset: %d, usedmask[0]: %x, freemask: %x\n", offset, maxoffset, usedmask[0], freemask[0]);
        gencode(caller, callee);
	fprint(stderr, "End gencode(), offset: %d, usedmask[0]: %x, freemask: %x\n", offset, usedmask[0], freemask[0]); 

	fprint(stderr, "Maxargoffset: %d, maxoffset: %d, offset: %d\n", maxargoffset, maxoffset, offset);
        framesize = roundup((maxargoffset > 64 ? maxargoffset - 64 : 0) + maxoffset, 8);
	fprint(stderr, "Framesize: %d\n", framesize);

        segment(CODE);
	print("%s\tIS\t@\n", f->x.name);
	if (maxoffset != offset || ncalls != 0) {
		fprint(stderr, "Adjusting frame by %d bytes\n", framesize);
		print("\tSTOU\t:__fp,:__sp,%d\n", fpoffset);
		print("\tSET\t:__fp,:__sp\n");
        	if (framesize > 0)
			if (framesize > 255) {
				emitintconst(255, 4, 0, framesize);
				print("\tADDU\t:__sp,:__sp,$255\n");
			} else {
				print("\tADDU\t:__sp,:__sp,%d\n", framesize);
			}
		if (ncalls != 0) {
			print("\tGET\t$255,:rJ\n");
			print("\tSTOU\t$255,:__fp,%d\n", rJoffset);
			fprint(stderr, "Storing rJ to offset %d\n", rJoffset);
		}
	}

	// store args if we are variadic
	if (variadic(f->type) && parameters < 8)
		for (i=7; i >= parameters; --i)
			print("\tSTOU\t$%d,:__fp,%d\n", i, (7-i)*8);
	
	// make sure we get read an incoming 4byte float in a reg > $7 from the correct address
	if (parameters > 8) {
		Symbol p;
		for (i=8; i<parameters; ++i) {
			p = caller[i];
			if (isfloat(p->type) && p->type->size == 4) {
				// load it in a register and store it at it's correct place
				emitintconst(250, 8, 1, p->x.offset-4);
				print("\tLDOU\t$255,:__fp,$250\n");
				print("\tADDU\t$250,$250,4\n");
				print("\tSTSF\t$255,:__fp,$250\n");
			}
		}
	}

	fprint(stderr, "Calling emitcode()\n");
        emitcode();
	fprint(stderr, "End emitcode()\n");

	// MMIX
	if (maxoffset != offset || ncalls != 0) {
		if (ncalls != 0) {
			print("\tLDOU\t$255,:__fp,%d\n", rJoffset);
			print("\tPUT\t:rJ,$255\n");
			fprint(stderr, "Storing rJ to offset %d\n", rJoffset);
		}
		if (framesize > 0)
			if (framesize > 255) {
				emitintconst(255,4,0,framesize);
				print("\tSUBU\t:__sp,:__sp,$255\n");
			} else
				print("\tSUBU\t:__sp,:__sp,%d\n", framesize);
		print("\tLDOU\t:__fp,:__sp,%d\n",fpoffset);
	}
	print("\tPOP\t%d,0\n", freturn(f->type)->op == VOID ? 0 : 1); 
	// MMIX end
}

static void defconst(int suffix, int size, Value v) {
    if (!gotlabel) print("\t");
    gotlabel = 0;

    // no tabs here as we are collaborating with global et al.
    if (suffix == F && size == 4) {
        float f = v.d;
        print("TETRA\t#%x\n", *(unsigned *)&f);
    } else if (suffix == F && size == 8) {
        double d = v.d;
	assert(sizeof(unsigned) == 4);
        unsigned *p = (unsigned *)&d;
        print("TETRA\t#%x,#%x\n", p[swap], p[!swap]);        
    } else if (suffix == P) {
        print("OCTA\t#%x\n", (unsigned long)(suffix == I ? v.i : v.u));
    } else if (size == 1) {
        print("BYTE\t#%x\n", (unsigned)((unsigned char)(suffix == I ? v.i : v.u)));
    } else if (size == 2) {
        print("WYDE\t#%x\n", (unsigned)((unsigned short)(suffix == I ? v.i : v.u)));
    } else if (size == 4) {
        print("TETRA\t#%x\n", (unsigned)(suffix == I ? v.i : v.u));
    } else if (size == 8) {
        print("OCTA\t#%x\n", (unsigned long)(suffix == I ? v.i : v.u));
    } else
        assert(0);
}

static void defaddress(Symbol p) {
    fprint(stderr, "defaddress(%s)\n", p->x.name);
    if (!gotlabel) print("\t");
    gotlabel = 0;
    print("OCTA\t%s\n", p->x.name);
}

static void defstring(int n, char *str) {
    int i;
    fprint(stderr, "defstring(%d,%s)\n", n, str);
    if (!gotlabel) print("\t");
    gotlabel = 0;
    print("BYTE\t");
    for (i = 0; i < n; ++i) {
	if (!(i % 10) && i >= 10) print("\n\tBYTE\t");
        else if (i != 0) print(",");
        print("#%x", str[i] & 0xff);
    }
    print("\n");
}

static void export(Symbol p) {}

static void import(Symbol p) {}

static void defsymbol(Symbol p) {
    fprint(stderr, "defsymbol(%s) sclass:%d, scope:%d, type:%d, generated: %d, Xsymbol: %d, temporary: %d, defined: %d\n", 
		p->name, p->sclass, p->scope, p->type, p->generated, p->x, p->temporary, p->defined);

    // mark global with the : prefix operator and local labels with L_
    if (p->generated) {
        p->x.name = stringf("L_%s", p->name);
    } else if (p->scope == LOCAL && p->sclass == STATIC) {
	p->x.name = stringf("%s_%d", p->name, genlabel(1));
    } else if (p->scope == GLOBAL && p->sclass != STATIC) {
        p->x.name = stringf(":%s", p->name);
    } else {
	p->x.name = p->name;
    }
}

static void address(Symbol q, Symbol p, long n) {
	fprint(stderr, "address(%s,%s,%d)\n", q->name, p->name, n);

	// Construct symbol q from p + offset n
	if (p->scope == GLOBAL || p->sclass == STATIC || p->sclass == EXTERN) {
		q->x.name = stringf("%s%s%d", p->x.name, n >= 0 ? "+" : "", n);
		q->x.offset = n;
	} else {
		q->x.offset = p->x.offset + n;
		q->x.name = stringd(q->x.offset);
	}
}

static void global(Symbol p) {
    fprint(stderr, "global(%s), align: %d, size:%d, segment: %d\n", p->name, p->type->align, p->type->size,p->u.seg);

    // TODO: do we need to clear the space with zeros accordig to standard
    //       p.492 [2]
    
    // TODO: can we omit the alignment for certain globals?? compile all progs and
    // look at all aligns and try to figure out a pattern ;) 
    // later: is a possible pattern if the size is bigger than the align?
    if (((p->type->size > p->type->align || p->u.seg == BSS) && p->type->align != 1) ||
	(p->type->size == 8 && isfloat(p->type)))
        print("\tLOC\t@+(%d-@)&%d\n", p->type->align, p->type->align-1);
    print("%s\t", p->x.name); // definition is going to be made by space/defconst/defstring
    gotlabel = 1;
}

static void segment(int n) {
    fprint(stderr, "segment(%d), old: %d\n", n, cseg);

    if (n == BSS || n == LIT) n = DATA; // all the same for us
    if (n == cseg) return;
    
    // end old segment and start new one
    switch (cseg) {
	case CODE:
	  print("8H\t");
	  break;
	case BSS:
	case DATA:
	case LIT:
	  print("9H\t");
	  break;
	//case -1: print("7H\t"); break;
    }
    switch (n) {
	case CODE:
	  print("LOC\t8B\t\t\t%% -- CODE SEGMENT --\n");
	  break;
	case BSS:
	case DATA:
	case LIT:
	  print("LOC\t9B\t\t\t%% -- DATA SEGMENT --\n");
	  break;
	//case -1: print("LOC\t7B\t\t\t// ADDRESSES\n"); break;
    }

    cseg = n;
}

static void space(int n) {
	fprint(stderr, "space(%d)\n", n);
	if (!gotlabel) print("\t");
	gotlabel = 0;
	print("LOC\t@+%d\n", n);
}

static void blkloop(int dreg, int doff, int sreg, int soff, int size, int tmps[]) {
	fprint(stderr, "blkloop(%d, %d, %d, %d, %d, (tmps[]))\n", dreg, doff, sreg, soff, size);
	char *offset;

	if (size&~7 >= 256) {
		emitintconst(255, 4, 0, size&~7);
		offset = "$255";
	} else offset = stringd(size&~7);

	// copy the ending (&7)
	print("\tLDA\t$%d,$%d,%s\n", sreg, sreg, offset);
	print("\tLDA\t$%d,$%d,%s\n", tmps[2], dreg, offset);
	blkcopy(tmps[2], doff, sreg, soff, size&7, tmps);

	// and now loop
	print("1H\tSUBU\t$%d,$%d,%d\n", sreg, sreg, 8);
	print("\tSUBU\t$%d,$%d,%d\n", tmps[2], tmps[2], 8);
	blkcopy(tmps[2], doff, sreg, soff, 8, tmps);
	print("\tCMPU\t$255,$%d,$%d\n", dreg, tmps[2]);
	print("\tBN\t$255,1B\n");
}

static void blkfetch(int size, int off, int reg, int tmp) {
	fprint(stderr, "blkfetch(%d, %d, %d, %d), dalign: %d, salign: %d\n", size, off, reg, tmp, dalign, salign);
	char *offset;

	if (off >= 256) {
		emitintconst(255, 4, 0, off);
		offset = "$255";
	} else offset = stringd(off);

        assert(size == 1 || size == 2 || size == 4 || size == 8);

        if (size == 1)
		print("\tLDB\t$%d,$%d,%s\n", tmp, reg, offset);
        else if (size == 2)
		print("\tLDW\t$%d,$%d,%s\n", tmp, reg, offset);
        else if (size == 4)
                print("\tLDT\t$%d,$%d,%s\n", tmp, reg, offset);
        else if (size == 8)
                print("\tLDO\t$%d,$%d,%s\n", tmp, reg, offset);
        else
		assert(0); 
}

static void blkstore(int size, int off, int reg, int tmp) {
	fprint(stderr, "blkstore(%d, %d, %d, %d), dalign: %d, salign: %d\n", size, off, reg, tmp, dalign, salign);
	char *offset;

	if (off >= 256) {
		emitintconst(255, 4, 0, off);
		offset = "$255";
	} else offset = stringd(off);

        assert(size == 1 || size == 2 || size == 4 || size == 8);
        if (size == 1)
		print("\tSTB\t$%d,$%d,%s\n", tmp, reg, offset);
        else if (size == 2)
		print("\tSTW\t$%d,$%d,%s\n", tmp, reg, offset);
        else if (size == 4)
                print("\tSTT\t$%d,$%d,%s\n", tmp, reg, offset);
        else if (size == 8)
                print("\tSTO\t$%d,$%d,%s\n", tmp, reg, offset);
        else
		assert(0); 
}

static void stabinit(char *file, int argc, char *argv[]) {
	fprint(stderr, "stabinit(%s, %d, %d)\n", file, argc, argv);
}

static void stabline(Coordinate *cp) {
	fprint(stderr, "stabline([%s,%d,%d])\n", cp->file, cp->x, cp->y);
	print("# %d \"%s\"\n", cp->y, cp->file);
}

static void stabsym(Symbol p) 
{
    fprint(stderr, "stabsym(%s)\n", p->name);
}

static void stabtype(Symbol p) 
{
    fprint(stderr, "stabtype(%s)\n", p->name);
}

static void stabfend(Symbol p, int lineno) 
{
    fprint(stderr, "stabfend(%s,%d)\n", p->name, lineno);
}

static void stabblock(int brace, int lev, Symbol *p) 
{
    fprint(stderr, "stabblock(%d,%d)\n", brace, lev);
}

static void stabend(Coordinate *cp, Symbol p, Coordinate **cpp, Symbol *sp, Symbol *stab) 
{
    fprint(stderr, "stabend([%s,%d,%d], (symbol), (coordlist), (sp), (stab))\n", cp->file, cp->x, cp->y);
}

Interface mmixIR = {
        1, 1, 0,  /* char */
        2, 2, 0,  /* short */
        4, 4, 0,  /* int */
        8, 8, 0,  /* long */
        8, 8, 0,  /* long long */
        4, 4, 1,  /* float */
        8, 8, 1,  /* double */
        8, 8, 1,  /* long double */
        8, 8, 0,  /* T * */
        0, 1, 0,  /* struct */

        0,  /* little_endian */
        0,  /* mulops_calls */
        0,  /* wants_callb */
        0,  /* wants_argb */
        1,  /* left_to_right */
        0,  /* wants_dag */
        0,  /* unsigned_char */
        address,
        blockbeg,
        blockend,
        defaddress,
        defconst,
        defstring,
        defsymbol,
        emit,
        export,
        function,
        gen,
        global,
        import,
        local,
        progbeg,
        progend,
        segment,
        space,
        stabblock,
	stabend, 
	stabfend, 
	stabinit, 
	stabline, 
	stabsym, 
	stabtype,
        {
                1,      /* max_unaligned_load */
                rmap,
                blkfetch, blkstore, blkloop,
                _label,
                _rule,
                _nts,
                _kids,
                _string,
                _templates,
                _isinstruction,
                _ntname,
                emit2,
                doarg,
                target,
                clobber,
        }
};


static char rcsid[] = "$Id: alpha.md,v 1.1.1.1 2004/10/29 08:30:02 martin Exp $";

