/*
 * arith.h -- arithmetic subroutines
 */


#ifndef _ARITH_H_
#define _ARITH_H_


extern Octa zero;			/* 0 */
extern Octa one;			/* 1 */
extern Octa negOne;			/* -1 */

extern Octa auxOut;			/* secondary arithmetic output */
extern Bool overflow;			/* flag signalling overflow */


Octa incOcta(Octa y, int delta);

Octa addOcta(Octa y, Octa z);
Octa subOcta(Octa y, Octa z);
Octa umulOcta(Octa y, Octa z);		/* sets auxOut */
Octa mulOcta(Octa y, Octa z);		/* sets auxOut and overflow */
Octa udivOcta(Octa x, Octa y, Octa z);	/* sets auxOut */
Octa divOcta(Octa y, Octa z);		/* sets auxOut and overflow */

Octa andOcta(Octa y, Octa z);
Octa orOcta(Octa y, Octa z);
Octa xorOcta(Octa y, Octa z);
Octa andnOcta(Octa y, Octa z);
Octa ornOcta(Octa y, Octa z);
Octa nandOcta(Octa y, Octa z);
Octa norOcta(Octa y, Octa z);
Octa nxorOcta(Octa y, Octa z);
Octa muxOcta(Octa y, Octa z, Octa m);
Octa bdifOcta(Octa y, Octa z);
Octa wdifOcta(Octa y, Octa z);
Octa tdifOcta(Octa y, Octa z);
Octa odifOcta(Octa y, Octa z);
Octa saddOcta(Octa y, Octa z);
Octa morOcta(Octa y, Octa z);
Octa mxorOcta(Octa y, Octa z);

Octa shlOcta(Octa y, int n);
Octa shrOcta(Octa y, int n);
Octa sarOcta(Octa y, int n);

Bool ultOcta(Octa y, Octa z);
Bool ugtOcta(Octa y, Octa z);


#endif /* _ARITH_H_ */
