%
% rom07.mms - more realistic subroutine call & return
%

	LOC	#8000800000000000

Main	JMP	Start

%	$0	digit to output, gets converted to ASCII
%	$1	base address of terminal registers
%		+0  is receiver status
%		+8  is receiver data
%		+16 is transmitter status
%		+24 is transmitter data
%	$2	temporary

OutPB	SETH	$1,#8001	% set terminal base address
	ADDU	$0,$0,#0030	% convert digit to ASCII
2H	SYNC	0		% drain pipeline
	LDOU	$2,$1,16	% load status word into $2
	AND	$2,$2,#1	% extract LSB
	PBZ	$2,2B		% loop while transmitter not ready
	STOU	$0,$1,24	% write character to terminal
	SYNCD	7,$1,24		% empty write buffer
	SUBU	$0,$0,#0030	% convert back to digit
	POP	2,0		% return

Start	SETH	$0,#1234	% waste two registers
	ORL	$0,#56
	SETH	$1,#ABCD
	ORL	$1,#EF
	SETH	$2,#0000	% set digit to display
	ORL	$2,#0001
1H	PUSHJ	$1,OutPB	% fadeout registers $0 and $1, pass $2 as $0
	ADDU	$2,$2,1		% increment digit
	CMP	$1,$2,10	% we only handle a single digit
	PBNZ	$1,1B		% ok - go on
	JMP	Start		% else start all over again
