/*
 * term.h -- terminal simulation
 */


#ifndef _TERM_H_
#define _TERM_H_


#define TERM_RCVR_CTRL		0	/* receiver control register */
#define TERM_RCVR_DATA		8	/* receiver data register */
#define TERM_XMTR_CTRL		16	/* transmitter control register */
#define TERM_XMTR_DATA		24	/* transmitter data register */

#define TERM_RCVR_RDY		0x01	/* receiver has a character */
#define TERM_RCVR_IEN		0x02	/* enable receiver interrupt */
#define TERM_RCVR_MSEC		20	/* input checking interval */

#define TERM_XMTR_RDY		0x01	/* transmitter accepts a character */
#define TERM_XMTR_IEN		0x02	/* enable transmitter interrupt */
#define TERM_XMTR_MSEC		8	/* output speed */


octa termRead(int dev, tetra addr);
void termWrite(int dev, tetra addr, octa data);

void termReset(void);
void termInit(int numTerms);
void termExit(void);


#endif /* _TERM_H_ */
